Subject: Re: [PATCH RFC v4 0/9] Introduce Rust and announce that it will become mandatory

From: "brian m. carlson" <[email-masked]>
Date: Thu, 11 Sep 2025 21:55:54 +0000

On 2025-09-10 at 15:35:46, Patrick Steinhardt wrote:
> Hi,
> 
> this small patch series introduces Rust into the core of Git. This patch
> series is designed as a test balloon, similar to how we introduced test
> balloons for C99 features in the past. The goal is threefold:
> 
>   - Give us some time to experiment with Rust and introduce proper build
>     infrastructure.
> 
>   - Give distributors time to ease into the new toolchain requirements.
>     Introducing Rust is impossible for some platforms and hard for
>     others.
> 
>   - Announce that Git 3.0 will make Rust a mandatory part of our build
>     infrastructure.
> 
> The test balloon itself is quite uninteresting: I've chosen to convert
> the "varint.c" subsystem, mostly because it is trivial and does not have
> any dependencies. But it does allow us to verify that C to Rust interop
> works as expected, and to play around with tooling. All tests pass with
> the "varint.rs" implementation.
> 
> For now, the series only contains support for Meson. If we agree to go
> down this route I'll also introduce support for Rust into our Makefiles
> at a later point in time.
> 
> Furthermore missing is additional tooling:
> 
>   - At least one CI job to verify that Rust builds and works as
>     expected.
> 
>   - Tooling and CI jobs to ensure that we have consistent formatting via
>     `cargo format`.
> 
> And probably lots more. As said, the entire goal is for us to have an
> easy playground that we can experiment on and develop the infrastructure
> incrementally without yet having to commit to anything.

I may end up sending in a patch or two for these if I have some time.

I did note the discussion about what the LTS process looks like, which I
don't have strong opinions about but do want to make sure the project
(including folks on the security list) is willing to support.  Other
than that, this series looked reasonable to me.  I also confirmed that
it works with my existing sha256-interop-part-2 series, which I
appreciate.

I think once we have agreement on the LTS process, this should be good
to go.
-- 
brian m. carlson (they/them)
Toronto, Ontario, CA